<template>
  <div>
    <table width="100%" style="height:30rem">
      <thead>
        <tr>
          <th width="20%">{{ $t('components.trainborard.trainno') }}</th>
          <th width="20%">{{ $t('components.trainborard.gotime') }}</th>
          <th width="20%">{{ $t('components.trainborard.arrivestaion') }}</th>
          <th width="20%">{{ $t('components.trainborard.pass') }}</th>
          <th width="20%">{{ $t('components.trainborard.direction') }}</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="( itdata,index ) in historyData" :key="index+'td'" class="tc">
          <td class="p-5">
            <font v-if="itdata.TrainTypeCode === '10' ">
              <Icon type="md-train" />-{{ $t('components.trainborard.Shuttlebusfast') }}
            </font>
            <font v-if="itdata.TrainTypeCode === '7'  ">
              <Icon type="md-train" />-{{ $t('components.trainborard.normalfast') }}
            </font>
            <font v-if="itdata.TrainTypeCode === '6'  ">
              <Icon type="md-train" />-{{ $t('components.trainborard.Shuttlebus') }}
            </font>
            <font v-if="itdata.TrainTypeCode === '4'  ">
              <Icon type="md-train" style="color:#0069c2" />-{{ $t('components.trainborard.ChuKuang') }}
            </font>
            <font v-if="itdata.TrainTypeCode === '3'  ">
              <Icon type="md-train" style="color:orange" />-{{ $t('components.trainborard.TzeChiang') }}
            </font>
            <font v-if="itdata.TrainTypeCode === '2'  ">
              <Icon type="md-train" style="color:#d00216" />-{{ $t('components.trainborard.Puoma') }}
            </font>
            <font v-if="itdata.TrainTypeCode === '1'  ">
              <Icon type="md-train" style="color:#d00216" />-{{ $t('components.trainborard.TarokoExpress') }}
            </font>
            ({{ itdata.TrainNo}})
          </td>
          <td>{{ itdata.DepartureTime }}</td>
          <td>{{ itdata.EndingStationName }}</td>
          <td v-if="itdata.TripLine === 0">{{ $t('components.trainborard.nospan') }}</td>
          <td v-if="itdata.TripLine === 1">{{ $t('components.trainborard.spanmountain') }}</td>
          <td v-if="itdata.TripLine === 2">{{ $t('components.trainborard.spanmsea') }}</td>
          <td v-if="itdata.Direction === 0" style="color:blue">{{ $t('components.trainborard.Forward') }}</td>
          <td v-if="itdata.Direction === 1" style="color:red">{{ $t('components.trainborard.Retrograde') }}</td>
        </tr>
        <tr v-if="historyData == ''">
          <td colspan="10" class="tc p-5">{{ $t('trainborard.noform') }}</td>
        </tr>
      </tbody>
    </table>
    <Page
      class="mt-10 mb-10 fr"
      :total="dataCount"
      ref="pages" 
      :page-size="pageSize"
      simple
      @on-change="changepage"
    ></Page>
  </div>
</template>

<script>
import moment from "moment";
export default {
  props: {
    tableboard: {
      type: Array,
      default: () => ({
        TrainDate: String,
        StationID: String,
        StationName: {
          Zh_tw: String,
          En: String
        },
        TrainNo: String,
        Direction: Number,
        TripLine: Number,
        TrainTypeID: String,
        TrainTypeCode: String,
        TrainTypeName: {
          Zh_tw: String,
          En: String
        },
        StartingStationID: String,
        StartingStationName: String,
        EndingStationID: String,
        EndingStationName: String,
        ArrivalTime: String,
        DepartureTime: String,
        UpdateTime: String,
        VersionID: Number
      })
    }
  },
  data() {
    return {
      ajaxHistoryData: [],
      // 初始化信息总条数
      dataCount: 0,
      // 每页显示多少条
      pageSize: 10,
      historyData: []
    };
  },
  computed: {
    fixdata() {
      const nowtime = moment(Date.now()).format("x")
      const date = this.tableboard
        .slice()
        .filter(items => {
          return moment(items.TrainDate+' '+items.DepartureTime).format("x") > nowtime
        })
        .sort((a, b) => (a.DepartureTime > b.DepartureTime ? 1 : -1));
      return date;
    }
  },
  watch: {
    tableboard(val) {
      this.handleListApproveHistory();
      const date = val.map(item => Object.values(item)[0].ArrivalTime);
    }
  },
  methods: {
    // 获取历史记录信息
    handleListApproveHistory() {
      // 保存取到的所有数据
      this.ajaxHistoryData = this.fixdata;
      this.dataCount = this.fixdata.length;
      // 初始化显示，小于每页显示条数，全显，大于每页显示条数，取前每页条数显示
      if (this.fixdata.length < this.pageSize) {
        this.historyData = this.ajaxHistoryData;
      } else {
        this.historyData = this.ajaxHistoryData.slice(0, this.pageSize);
      }
      this.$nextTick(()=>{
          this.$refs['pages'].currentPage = 1;
      })
    },
    changepage(index) {
      var _start = (index - 1) * this.pageSize;
      var _end = index * this.pageSize;
      this.historyData = this.ajaxHistoryData.slice(_start, _end);
    }
  }
};
</script>
